/*
 *===================================================================================================================
 * 																													
 *	Copyright �2013 [see full license agreement, license.txt]
 *	Radu Calinescu, Kenneth Johnson and Yasmin Rafiq, 
 *  {radu.calinescu, kenneth.johnson, yr534}@york.ac.uk> (University of York)
 *===================================================================================================================  
 *
 *	This file is part of the COVE tool suite for the development of self-adaptive service based systems. 
 *					
 *		The COVE tool suite is free software: you can redistribute it and/or modify it 				
 *		under the terms of the GNU Affero General Public License as published by the Free Software Foundation,  		
 *		either version 3 of the License, or (at your option) any later version.  																			
 *																																																																														
 *		You should have received a copy of the GNU Affero General Public License along with IPGen. 
 *		If not, see <http://www.gnu.org/licenses/> 						
 * 																													
 *===================================================================================================================
 */


package gui;

import holtjp.proxygen.webservice.EasyWSDLWebService;
import holtjp.proxygen.webservice.WebService;

import java.awt.Dialog;
import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.net.MalformedURLException;
import java.net.URL;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JTextField;

import javax.swing.JLabel;

public class LoadNewWsdlDialog extends JDialog {


	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private final JTextField urlTextBox;

	private LoadNewWsdlDialog self = this;

	public LoadNewWsdlDialog(JFrame parent,final GUI gui){
		super(parent,Dialog.ModalityType.APPLICATION_MODAL);

		setPreferredSize(new Dimension(500,150));
		setLayout(new GridLayout(2,2,5,5));

		add(new JLabel("Wsdl URL:"));
		urlTextBox = new JTextField();
		add(urlTextBox);

		JButton b = new JButton("Load");
		b.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				WebService ws = new EasyWSDLWebService();
				try {
					ws.load(new URL(urlTextBox.getText()));
					gui.addNewWebService(ws);
				} catch (MalformedURLException e1) {
					// TODO Auto-generated catch block

					e1.printStackTrace();
				}
				self.setVisible(false);    


			}
		});
		add(b);
		pack();

	}
}
